#include "a_Structure.h"
#include "d_Bitboard_const.h"

#define TEST_B 0   // -(1-0)      
#define KONTROL_B 0 // -(1-0)   

//---------------------------------------------------------------------------
/*
 *    (Brenkman Andrey)
 *   21.02.2009
*/
//---------------------------------------------------------------------------

/*
    99,99999%

  (bit board) 

     .   
   :
 "Hyatt, Robert. Rotated bitmaps, a new twist on an old idea"

      T_Bitboard    T_list_surplus_moves
            
 +   

              
            

 
        
   (21.02.09) (bugs)  

*/

namespace BITBOARDGENERATOR
{
	//---------------------------------------------------------------------------
	//    +   ( )
	void public_generator_captures_white
	(
		const struct T_Bitboard * const p_bitboard,//  
		struct T_list_surplus_moves * const p_list_surplus_moves//                  
	);

	//---------------------------------------------------------------------------
	//     +   ( )
	void public_generator_captures_black
	(
		const struct T_Bitboard * const p_bitboard,//  
		struct T_list_surplus_moves * const p_list_surplus_moves//  
	);


	//---------------------------------------------------------------------------
	//     
	// (..     +  )( )
	void public_generator_move_white
	(
		const struct T_Bitboard * const p_bitboard,//  
		struct T_list_surplus_moves * const p_list_surplus_moves//  
	);

	//---------------------------------------------------------------------------
	//     
	// (..     +  )( )
	void public_generator_move_black
	(
		const struct T_Bitboard * const p_bitboard,//  
		struct T_list_surplus_moves * const p_list_surplus_moves//  
	);

	//---------------------------------------------------------------------------
	//           
	//  0    
	unsigned __int8 public_king_white_check
	(
		const struct T_Bitboard * const p_bitboard//  
	);

	//---------------------------------------------------------------------------
	//           
	//  0    
	unsigned __int8 public_king_black_check
	(
		const struct T_Bitboard * const p_bitboard//  
	);


//---------------------------------------------------------------------------
//  (bit board) 
#if TEST_B
	void Bitboard_print
	(
		const struct T_Bitboard * p_bitboard//  
	);
#endif//TEST_B


//////////////////////////////////////////////////////////////////////////////////////////
//private:

	//---------------------------------------------------------------------------
	//           
	//  0    
	inline unsigned __int8 white_check_square
	(
		const unsigned __int8 & sq,//  (0-63) 
		const struct T_Bitboard * const p_bitboard//  
	);

	//---------------------------------------------------------------------------
	//           
	//  0    
	inline unsigned __int8 black_check_square
	(
		const unsigned __int8 & sq,//  (0-63) 
		const struct T_Bitboard * const p_bitboard//  
	);

	//---------------------------------------------------------------------------
	//   
	inline void bitboard_ini_t
	(
		struct T_Bitboard * p_bitboard//  
	);

	//---------------------------------------------------------------------------
	//    -   
	//        ( )
	inline void list_capture_white
	(
		unsigned __int8 name,//   
		unsigned __int8 type_move,//  
		const unsigned __int8 & from,//  
		const unsigned __int8 & to,//  
		unsigned __int8 & count,//    
		const struct T_Bitboard * const p_bitboard,//  
		struct T_list_surplus_moves * const p_list_surplus_moves//  
	);

	//---------------------------------------------------------------------------
	//    -   
	//        ( )
	inline void list_capture_black
	(
		unsigned __int8 name,//   
		unsigned __int8 type_move,//  
		const unsigned __int8 & from,//  
		const unsigned __int8 & to,//  
		unsigned __int8 & count,//    
		const struct T_Bitboard * const p_bitboard,//  
		struct T_list_surplus_moves * const p_list_surplus_moves//  
	);

	//---------------------------------------------------------------------------
	//   
	inline void list_record_move
	(
		unsigned __int8 name,//   
		unsigned __int8 type_move,//  
		const unsigned __int8 & from,//  
		const unsigned __int8 & to,//  
		unsigned __int8 & count,//    
		const struct T_Bitboard * const p_bitboard,//  
		struct T_list_surplus_moves * const p_list_surplus_moves//  
	);

	//---------------------------------------------------------------------------
	//         
	//      
	inline void list_record_special
	(
		unsigned __int8 name,//   
		unsigned __int8 d_m,//  
		unsigned __int8 & p,//    
		const unsigned __int8 & from,//  
		unsigned __int8 to,//  
		unsigned __int8 capture,//   
		struct T_list_surplus_moves * const p_list_surplus_moves//  
	);

	//---------------------------------------------------------------------------
	//     ,         
	//       
	inline void KONTROL_captures_W
	(
		const struct T_Bitboard * p_bitboard,//  
		const unsigned __int8 * p_from,//   
		const unsigned __int8 * p_to,//   
		const unsigned __int8 * p_p,//    
		unsigned __int8 name_figure//   
	);

	//---------------------------------------------------------------------------
	//     ,         
	//       
	inline void KONTROL_captures_B
	(
		const struct T_Bitboard * p_bitboard,//  
		const unsigned __int8 * p_from,//   
		const unsigned __int8 * p_to,//   
		const unsigned __int8 * p_p,//    
		unsigned __int8 name_figure//   
	);

	//---------------------------------------------------------------------------
	//     ,    
	//    
	inline void KONTROL_move
	(
		const unsigned __int8 * p_from,//   
		const unsigned __int8 * p_to,//   
		const unsigned __int8 * p_p//    
	);

	//---------------------------------------------------------------------------
	//    (..  )
	__inline __int32 bit_scan_forward_win32
	(
		unsigned __int64 analyzed_number//      
	);

	//---------------------------------------------------------------------------
	//    (..  )
	__inline __int32 bit_scan_reverse_win32
	(
		unsigned __int64 analyzed_number//      
	);

}


/*

              &  0 0 1  
                  0 1 1  
                  -----
                  0 0 1 

            |  0 0 1
                  0 1 1
                  -----
                  0 1 1

    ^  0 0 1
               0 1 1
                  -----
                  0 1 0

*/